
#ifndef TGAIMG_h
#define TGAIMG_h

#include <stdio.h>
#include <stdlib.h>

enum format{ LUMINANCE = 0,
			 RGBA,
			 RGB,
};

class tga_image {

public:

	tga_image(char* file_name); // loads an image from file 
	tga_image();				// default constructor
	~tga_image();				// destructor

	bool load_TGA(char* file_name);
	unsigned char* get_ptr_image_data(); // returns a pointer to image data
	int get_width();
	int get_height();
	int get_format();

protected:

	int check_size (int x);
	unsigned char* get_RGBA (FILE *f_ptr, int size);
	unsigned char* get_RGB (FILE* f_ptr, int size);
	unsigned char* get_gray (FILE *f_ptr, int size);
	unsigned char* get_data (FILE *f_ptr, int sz, int iBits);

	unsigned char* imageData; // pointer to raw image data

	// data about image
	int imageWidth, imageHeight;
	int imageBits, size;
	int imageFormat;
};

#endif